#!/usr/bin/env node
var $kADsQ$yargs = require("yargs");
var $kADsQ$graphql = require("graphql");
var $kADsQ$fspromises = require("fs/promises");
var $kADsQ$undici = require("undici");
var $kADsQ$glob = require("glob");
var $kADsQ$path = require("path");
var $kADsQ$fs = require("fs");






var $7f0b78d14cf1360d$var$$parcel$__dirname = $kADsQ$path.resolve(__dirname, "../src");
const $7f0b78d14cf1360d$export$c6d1ad8c1472a6e0 = $kADsQ$fs.readFileSync($7f0b78d14cf1360d$var$$parcel$__dirname + "/preamble.src.ts", "utf8").split("/* BEGIN PREAMBLE */")[1];


const $255364aeb8b06edb$export$19f0310b66f395cf = (operations)=>operations.map((op)=>`
export function ${op}<Sel extends Selection<$RootTypes.${op}>>(
  selectFn: (q: $RootTypes.${op}) => [...Sel]
) {
  let field = new $Field<'${op}', GetOutput<Sel>, GetVariables<Sel>>('${op}', {
    selection: selectFn(new $Root.${op}()),
  })
  const str = fieldToQuery('${op}', field)

  return gql(str) as any as TypedDocumentNode<GetOutput<Sel>, GetVariables<Sel>>
}
`).join("\n");



class $556c0eeb2c5f3064$export$29ccbfbca6bccc64 extends Error {
    userFacingError = true;
    static is(e) {
        return e != null && "userFacingError" in e;
    }
}



async function $01a5df0e517e7468$export$ef7acd7185315e22(args) {
    const schemaData = await $01a5df0e517e7468$var$fetchOrRead(args);
    const outputScript = $01a5df0e517e7468$export$ea87c14c291919b6(schemaData);
    if (args.output === "") console.log(outputScript);
    else await $kADsQ$fspromises.writeFile(args.output, outputScript);
}
async function $01a5df0e517e7468$var$fetchOrRead(args) {
    let loadedSchemas = [];
    let schemas = Array.isArray(args.schema) ? args.schema : [
        args.schema
    ];
    for (let schemaSpec of schemas){
        if (/^https?:\/\//.test(schemaSpec)) {
            let headers = args.headers ?? [];
            let res = await (0, $kADsQ$undici.request)(schemaSpec, {
                method: "POST",
                headers: [
                    ...headers.flatMap((h)=>h.split(":")),
                    "content-type",
                    "application/json"
                ],
                body: JSON.stringify({
                    operationName: "IntrospectionQuery",
                    query: $kADsQ$graphql.getIntrospectionQuery()
                })
            });
            let body = await res.body.json();
            if (body.errors) throw new (0, $556c0eeb2c5f3064$export$29ccbfbca6bccc64)(`Error introspecting schema from ${args.schema}: ${JSON.stringify(body.errors, null, 2)}`);
            loadedSchemas.push($kADsQ$graphql.printSchema($kADsQ$graphql.buildClientSchema(body.data)));
        } else if (args.schema === "") {
            let res1 = "";
            for await (let data of process.stdin)res1 += String(data);
            loadedSchemas.push(res1);
        } else for (let fileName of (0, $kADsQ$glob.glob).sync(schemaSpec))loadedSchemas.push(await $kADsQ$fspromises.readFile(fileName, "utf8"));
    }
    return loadedSchemas;
}
function $01a5df0e517e7468$export$ea87c14c291919b6(schemaStrings) {
    let outputScript = "";
    const write = (s)=>{
        outputScript += s + "\n";
    };
    const outputObjectTypeNames = new Set();
    let schemaArray = Array.isArray(schemaStrings) ? schemaStrings : [
        schemaStrings
    ];
    let schemas = schemaArray.map((schemaString)=>$kADsQ$graphql.parse(schemaString, {
            noLocation: true
        }));
    let schemaDefinitions = schemas.flatMap((s)=>s.definitions);
    const enumTypes = schemaDefinitions.flatMap((def)=>{
        if (def.kind === $kADsQ$graphql.Kind.ENUM_TYPE_DEFINITION) return [
            def.name.value
        ];
        return [];
    });
    const scalarTypes = schemaDefinitions.flatMap((def)=>{
        if (def.kind === $kADsQ$graphql.Kind.SCALAR_TYPE_DEFINITION) return [
            def.name.value
        ];
        return [];
    });
    const schemaExtensionsMap = schemaDefinitions.filter($kADsQ$graphql.isTypeExtensionNode).reduce((acc, el)=>{
        acc.has(el.name.value) ? acc.get(el.name.value).push(el) : acc.set(el.name.value, [
            el
        ]);
        return acc;
    }, new Map());
    function getExtendedFields(sd) {
        return (sd.fields || []).concat((schemaExtensionsMap.get(sd.name.value) || []).flatMap((n)=>n.fields || []));
    }
    const atomicTypes = new Map(scalarTypes.map((st)=>[
            st,
            "string"
        ]).concat(enumTypes.map((et)=>[
            et,
            et
        ])).concat([
        [
            "Int",
            "number"
        ],
        [
            "Float",
            "number"
        ],
        [
            "ID",
            "string"
        ],
        [
            "String",
            "string"
        ],
        [
            "Boolean",
            "boolean"
        ], 
    ]));
    const inheritanceMap = new Map(schemaDefinitions.flatMap((def)=>{
        if (def.kind === $kADsQ$graphql.Kind.OBJECT_TYPE_DEFINITION) return [
            [
                def.name.value,
                def.interfaces?.map((ifc)=>ifc.name.value)
            ]
        ];
        return [];
    }));
    function isAtomic(typeName) {
        return !!atomicTypes.get(typeName);
    }
    function toTSType(scalar) {
        return atomicTypes.get(scalar) ?? scalar;
    }
    function printAtomicTypes() {
        return `type $Atomic = ${Array.from(new Set(atomicTypes.values())).join(" | ")}
`;
    }
    function printEnumList() {
        return `let $Enums = new Set<string>(${JSON.stringify(enumTypes)})
`;
    }
    function printTypeWrapped(wrappedType, wrapperDef, notNull = false) {
        switch(wrapperDef.kind){
            case $kADsQ$graphql.Kind.NON_NULL_TYPE:
                return `${printTypeWrapped(wrappedType, wrapperDef.type, true)}`;
            case $kADsQ$graphql.Kind.LIST_TYPE:
                return `Array<${printTypeWrapped(wrappedType, wrapperDef.type)}>${!notNull ? " | undefined" : ""}`;
            case $kADsQ$graphql.Kind.NAMED_TYPE:
                return `${toTSType(wrappedType)}${!notNull ? " | undefined" : ""}`;
        }
    }
    function printType(def, notNull = false) {
        switch(def.kind){
            case $kADsQ$graphql.Kind.NON_NULL_TYPE:
                return `${printType(def.type, true)}`;
            case $kADsQ$graphql.Kind.LIST_TYPE:
                return `Readonly<Array<${printType(def.type)}>>${!notNull ? " | null | undefined" : ""}`;
            case $kADsQ$graphql.Kind.NAMED_TYPE:
                return `${toTSType(def.name.value)}${!notNull ? " | null | undefined" : ""}`;
        }
    }
    function printTypeGql(def, notNull = false) {
        switch(def.kind){
            case $kADsQ$graphql.Kind.NON_NULL_TYPE:
                return `${printTypeGql(def.type, true)}`;
            case $kADsQ$graphql.Kind.LIST_TYPE:
                return `[${printTypeGql(def.type)}]${notNull ? "!" : ""}`;
            case $kADsQ$graphql.Kind.NAMED_TYPE:
                return `${def.name.value}${notNull ? "!" : ""}`;
        }
    }
    function printTypeBase(def) {
        switch(def.kind){
            case $kADsQ$graphql.Kind.NON_NULL_TYPE:
                return `${printTypeBase(def.type)}`;
            case $kADsQ$graphql.Kind.LIST_TYPE:
                return `${printTypeBase(def.type)}`;
            case $kADsQ$graphql.Kind.NAMED_TYPE:
                return `${def.name.value}`;
        }
    }
    function printInputField(def) {
        const maybe = def.type.kind !== $kADsQ$graphql.Kind.NON_NULL_TYPE ? "?" : "";
        return `${def.name.value}${maybe}: ${printType(def.type)}`;
    }
    function printDocumentation(description) {
        return description?.value.length ?? false ? `
/**
 * ${description?.value}
 */` : "";
    }
    function printObjectType(def) {
        const className = def.name.value;
        return `
${printDocumentation(def.description)}
export class ${className} extends $Base<"${className}"> {
  constructor() {
    super("${className}")
  }

  ${getExtendedFields(def).map((f)=>printField(f, className)).join("\n")}
}`;
    }
    function generateFunctionFieldDefinition(field, includeArgs) {
        const methodArgs = [];
        const fieldTypeName = printTypeBase(field.type);
        let hasArgs = false, hasSelector = false;
        if (field.arguments?.length && includeArgs) {
            hasArgs = true;
            methodArgs.push(`args: Args`);
        }
        if (!isAtomic(fieldTypeName)) {
            hasSelector = true;
            methodArgs.push(`selectorFn: (s: ${fieldTypeName}) => [...Sel]`);
        }
        if (methodArgs.length > 0) {
            let extractArgs = "";
            let methodArgsSerialized = methodArgs.join(", ");
            const argsType = `{
        ${(field.arguments ?? []).map((arg)=>printInputField(arg)).join("\n")},
      }`;
            const generics = (hasArgs ? [
                `Args extends VariabledInput<${argsType}>`
            ] : []).concat(hasSelector ? [
                `Sel extends Selection<${fieldTypeName}>`
            ] : []);
            return `${field.name.value}<${generics.join(",")}>(${methodArgsSerialized}):$Field<"${field.name.value}", ${hasSelector ? printTypeWrapped("GetOutput<Sel>", field.type) : printType(field.type)} ${hasArgs ? `, GetVariables<${hasSelector ? "Sel" : "[]"}, Args>` : ", GetVariables<Sel>"}>`;
        } else throw new Error("Attempting to generate function field definition for non-function field");
    }
    function printField(field, parentName) {
        const fieldTypeName = printTypeBase(field.type);
        let hasArgs = !!field.arguments?.length, hasSelector = !isAtomic(fieldTypeName);
        if (hasArgs || hasSelector) {
            let extractArgs = "";
            let validDefinitions = generateFunctionFieldDefinition(field, true);
            const hasOnlyMaybeInputs = (field.arguments ?? []).every((def)=>def.type.kind !== $kADsQ$graphql.Kind.NON_NULL_TYPE);
            if (hasOnlyMaybeInputs && hasArgs && hasSelector) {
                validDefinitions += "\n" + generateFunctionFieldDefinition(field, false) + "\n" + `${field.name.value}(arg1: any, arg2?: any)`;
                extractArgs = `const { args, selectorFn } = !arg2 ? { args: {}, selectorFn: arg1 } : { args: arg1, selectorFn: arg2 };\n`;
            }
            return `
      ${printDocumentation(field.description)}
      ${validDefinitions} {
      ${extractArgs}
      const options = {
        ${hasArgs ? `argTypes: {
              ${field.arguments?.map((arg)=>`${arg.name.value}: "${printTypeGql(arg.type)}"`).join(",\n")}
            },` : ""}
        ${hasArgs ? `args,` : ""}

        ${hasSelector ? `selection: selectorFn(new ${fieldTypeName})` : ""}
      };
      return this.$_select("${field.name.value}", options) as any
    }
  `;
        } else return `
      ${printDocumentation(field.description)}
      get ${field.name.value}(): $Field<"${field.name.value}", ${printType(field.type)}>  {
       return this.$_select("${field.name.value}") as any
      }`;
    }
    function printInterface(def) {
        const className = def.name.value;
        return `
${printDocumentation(def.description)}
export class ${className} extends $Base<"${className}"> {
  constructor() {
    super("${className}")
  }
  ${getExtendedFields(def).map((f)=>printField(f, className)).join("\n")}

}`;
    }
    function printInputObjectType(def) {
        return `
${printDocumentation(def.description)}
export type ${def.name.value} = {
  ${getExtendedFields(def).map((field)=>printInputField(field)).join(",\n")}
}
    `;
    }
    function printInputTypeMap(defs) {
        return `
const $InputTypes: {[key: string]: {[key: string]: string}} = {
  ${defs.map((def)=>`  ${def.name.value}: {
    ${getExtendedFields(def).map((field)=>`${field.name.value}: "${printTypeGql(field.type)}"`).join(",\n")}
  }`).join(",\n")}
}
`;
    }
    function printScalar(def) {
        return `
${printDocumentation(def.description)}
export type ${def.name.value} = unknown
`;
    }
    function printUnion(def) {
        // TODO: collect all interfaces that the named type implements too
        const baseTypes = def.types?.map((t)=>printTypeBase(t)) ?? [];
        const additionalTypes = Array.from(new Set(baseTypes.concat(baseTypes.flatMap((bt)=>inheritanceMap.get(bt) ?? []))));
        const UnionObject = `{${additionalTypes.map((t)=>`${t}: ${t}`)}}`;
        return `
${printDocumentation(def.description)}
export class ${def.name.value} extends $Union<${UnionObject}, "${def.name.value}"> {
  constructor() {
    super(${UnionObject})
  }
}`;
    }
    function printEnumValue(def) {
        return `${printDocumentation(def.description)}
  ${def.name.value} = "${def.name.value}"`;
    }
    function printEnum(def) {
        return `
  ${printDocumentation(def.description)}
export enum ${def.name.value} {
  ${def.values?.map(printEnumValue).join(",\n")}
}
  `;
    }
    function printSchema(def) {
        return `
  const $Root = {
    ${def.operationTypes.map((op)=>`${op.operation}: ${printType(op.type, true)}`).join(",\n")}
  }

  namespace $RootTypes {
    ${def.operationTypes.map((op)=>`export type ${op.operation} = ${printType(op.type, true)}`).join("\n")}
  }
  `;
    }
    write((0, $7f0b78d14cf1360d$export$c6d1ad8c1472a6e0));
    write(printAtomicTypes());
    write(printEnumList());
    let rootNode = null;
    for (let def of schemaDefinitions)switch(def.kind){
        case $kADsQ$graphql.Kind.OBJECT_TYPE_DEFINITION:
            write(printObjectType(def));
            outputObjectTypeNames.add(def.name.value);
            break;
        case $kADsQ$graphql.Kind.INPUT_OBJECT_TYPE_DEFINITION:
            write(printInputObjectType(def));
            break;
        case $kADsQ$graphql.Kind.SCALAR_TYPE_DEFINITION:
            write(printScalar(def));
            break;
        case $kADsQ$graphql.Kind.UNION_TYPE_DEFINITION:
            write(printUnion(def));
            break;
        case $kADsQ$graphql.Kind.ENUM_TYPE_DEFINITION:
            write(printEnum(def));
            break;
        case $kADsQ$graphql.Kind.INTERFACE_TYPE_DEFINITION:
            write(printInterface(def));
            break;
        case $kADsQ$graphql.Kind.SCHEMA_DEFINITION:
            rootNode = def;
    }
    if (!rootNode) {
        if (!outputObjectTypeNames.has("Query")) throw new (0, $556c0eeb2c5f3064$export$29ccbfbca6bccc64)("Could not find toplevel root node or an output objet type named `Query`");
        rootNode = {
            kind: $kADsQ$graphql.Kind.SCHEMA_DEFINITION,
            operationTypes: [
                {
                    kind: $kADsQ$graphql.Kind.OPERATION_TYPE_DEFINITION,
                    operation: $kADsQ$graphql.OperationTypeNode.QUERY,
                    type: {
                        kind: $kADsQ$graphql.Kind.NAMED_TYPE,
                        name: {
                            kind: $kADsQ$graphql.Kind.NAME,
                            value: "Query"
                        }
                    }
                },
                ...outputObjectTypeNames.has("Mutation") ? [
                    {
                        kind: $kADsQ$graphql.Kind.OPERATION_TYPE_DEFINITION,
                        operation: $kADsQ$graphql.OperationTypeNode.MUTATION,
                        type: {
                            kind: $kADsQ$graphql.Kind.NAMED_TYPE,
                            name: {
                                kind: $kADsQ$graphql.Kind.NAME,
                                value: "Mutation"
                            }
                        }
                    }, 
                ] : [], 
            ]
        };
    }
    write(printSchema(rootNode));
    write((0, $255364aeb8b06edb$export$19f0310b66f395cf)(rootNode.operationTypes.map((o)=>o.operation.toString())));
    write(printInputTypeMap(schemaDefinitions.filter((def)=>def.kind === $kADsQ$graphql.Kind.INPUT_OBJECT_TYPE_DEFINITION)));
    return outputScript;
}



async function $53d878d34ed32e28$var$main() {
    const args = await $kADsQ$yargs.usage("Compiles a GraphQL schema to a TypeScript API").options({
        schema: {
            type: "array",
            string: true,
            describe: "Path (or glob) to local schema file or URL to a server with introspection",
            required: true
        },
        headers: {
            type: "array",
            describe: "Additional headers to send to the server if passing a server URL",
            default: []
        },
        schemaExtensions: {
            type: "array",
            describe: "Additional schemas that extend the base",
            required: false
        },
        output: {
            type: "string",
            describe: "The output TypeScript file",
            required: true
        }
    }).argv;
    try {
        await (0, $01a5df0e517e7468$export$ef7acd7185315e22)(args);
    } catch (e) {
        if ((0, $556c0eeb2c5f3064$export$29ccbfbca6bccc64).is(e)) {
            console.error(e.message);
            process.exit(1);
        } else throw e;
    }
}
$53d878d34ed32e28$var$main();


//# sourceMappingURL=cli.js.map
